{
  stdenvNoCC,
  fetchFromGitea,
  lib,
  selectedTheme ? "starship",
  screenNumber ? 0,
}:
let
  themeDetails = import ./themes.nix;
  # validThemes = builtins.attrNames themeDetails;
  # themeName = lib.checkListOfEnum "plymouth theme" validThemes selectedTheme;
  themeName = selectedTheme;
  theme = themeDetails.${themeName};
in
stdenvNoCC.mkDerivation {
  pname = "hudcore-plymouth";
  version = "${themeName}";

  src = fetchFromGitea {
    domain = "git.atagen.co";
    owner = "atagen";
    repo = "hudcore-plymouth";
    rev = theme.rev;
    hash = theme.hash;
  };

  installPhase =
    let
      templateScript = ./template.script;
      templatePlymouth = ./template.plymouth;
      themeScript = "${themeName}.script";
      themePlymouth = "${themeName}.plymouth";
    in
    ''
          cp ${templateScript} ${themeScript}
          sed -i 's/%SCREEN_NUMBER%/${toString screenNumber}/g' ${themeScript}
          sed -i 's/%FRAME_COUNT%/${toString theme.frameCount}/g' ${themeScript}

          cp ${templatePlymouth} ${themePlymouth}
          sed -i 's/%NAME%/${themeName}/g' ${themePlymouth}

        	mkdir -p $out/share/plymouth/themes/${themeName}
      		cp -r * $out/share/plymouth/themes/${themeName}
    '';

  passthru.updateScript = { };

  meta = {
    description = "Fantasy HUD Plymouth themes";
    longDescription = ''
      A set of mostly HUD-inspired plymouth boot screens.
      Default is `starship`.
      Override `selectedTheme` in order to pick a different one.
      Currently available:
      `nixdrop`
      `starship`
      `containment`
    '';
    homepage = "https://git.atagen.co/atagen/hudcore-plymouth";
    license = lib.licenses.gpl3;
    platforms = lib.platforms.linux;
    maintainers = [ lib.maintainers.atagen ];
  };
}
